/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.sea.modem;

import com.cinterion.io.*;
import java.io.IOException;

/**
 *
 * @author vorisek
 */
public class ATSender {

private ATCommand atc;
private final Object lock = new Object();
private String name = "?";

/**
 * Constructor
 */
public ATSender(boolean csdSupport, String name) throws ATCommandFailedException, IllegalStateException {
  atc = new ATCommand(csdSupport);
  this.name = "@" + name;
}

/**
 * Send AT command
 *
 * @param command
 * @return
 * @throws ATCommandFailedException
 */
public String send(String command) throws ATCommandFailedException {

  //com.sea.log.Logger.log(this.name, "q=" + command); // trace
  synchronized (lock) {
    String response = atc.send(command);
    //com.sea.log.Logger.log(this.name, "r=" + response); // trace 
    return response;
  }

}

/**
 * Execute AT command and return Exception if fails
 *
 * @param sCmd
 */
public String executeOK(String command) throws ATCommandFailedException {

  String s;
  String result;

  // Defensive programming
  s = command.toUpperCase();
  if (!s.startsWith("AT")) {
    throw new ATCommandFailedException("AT command has to begin with 'AT'");
  }

  result = send(command + "\r");
  if (result.indexOf("\r\nOK\r\n") < 0) {
    throw new ATCommandFailedException("AT command has failed. Original command '" + command + "', response '" + result + "'.");
  }

  return result;

}

public void release() throws IOException, IllegalStateException {
  atc.release();
}

public void addListener(ATCommandListener listener) {
  atc.addListener(listener);
}

}
