/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.sea.slave;

import com.sea.utils.Crc8;
import java.io.IOException;

/**
 * Create packet for SLAVE processor
 * 
 * +0 ... LENGTH(1) of CMD+DATA fields
 * +1 ... CRC(1) of  CMD+DATA fields
 * +2 ... CMD
 * +3..n ... DATA
 * 
 * @author vorisek
 */
public class OutputPacket {

// --------------------------------------------------
// Public Constants
// --------------------------------------------------
// --------------------------------------------------
// Public Properties
// --------------------------------------------------
// --------------------------------------------------
// Private Constants
// --------------------------------------------------
// --------------------------------------------------
// Private Properties
// --------------------------------------------------
private byte[] packet = new byte[256];
private int used;

// --------------------------------------------------
// Methods Service
// --------------------------------------------------
public OutputPacket() {
  used = 0;
}

// --------------------------------------------------
// Methods Public
// --------------------------------------------------
/**
 * Begin of a packet
 *
 * @param cmd
 * @throws IOException
 */
public void begin(int cmd) {
  used = 0;
  packet[used++] = 0x00;  // LENGTH in future
  packet[used++] = 0x00;  // CRC in future
  packet[used++] = (byte) cmd; // CRC in future
}

public void end() {
  packet[0] = (byte) (used - 2);   // LENGTH
  packet[1] = (byte) Crc8.countCrc8(packet, 2, used - 2); // CRC
}

public byte[] data() {
  return packet;
}

public int size() {
  return used;
}

public int capacity() {
  return packet.length;
}

/**
 * Write lower 8 bits (0.-7.)
 *
 * @param value
 * @throws IOException
 */
public void writeU8(int value) throws IOException {
  if (used >= packet.length) {
    throw new IOException("Packet too long.");
  }
  packet[used++] = (byte) value;
}

/**
 * Write lower 16 bits (0.-15.)
 *
 * @param value
 * @throws IOException
 */
public void writeU16(int value) throws IOException {
  if ((used + 1) >= packet.length) {
    throw new IOException("Packet too long.");
  }
  packet[used++] = (byte) (value >> 8);
  packet[used++] = (byte) value;
}

}
