package com.sea.slave;

import com.sea.utils.Utils;
import java.io.IOException;
import java.io.OutputStream;

/**
 *
 * @author Vorisek
 */
class StringHexComposer {
// --------------------------------------------------
// Public Properties
// --------------------------------------------------
// --------------------------------------------------
// Private Constants
// --------------------------------------------------

private static final byte[] HEXES = new byte[]{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};

// --------------------------------------------------
// Private Properties
// --------------------------------------------------
private byte[] buf;
private int pos;

// --------------------------------------------------
// Methods Service
// --------------------------------------------------
StringHexComposer(int size) {
  buf = new byte[size];
  pos = 0;
}

// --------------------------------------------------
// Methods Public
// --------------------------------------------------
public String toString() {
  return new String(buf, 0, pos);
}

public void reset() {
  pos = 0;
}

/**
 * "<a" -> "<a"
 * @
 *
 *
 *
 * param src
 * @throws Exception
 */
public StringHexComposer append(String src) throws Exception {
  byte[] srcArr = src.getBytes();
  for (int i = 0; i < srcArr.length; i++) {
    buf[pos++] = srcArr[i];
  }
  return this;
}

/**
 * {0x41, 0xA3} -> "41A3"
 *
 * @param src
 * @param offset
 * @param length
 */
public StringHexComposer appendHexString(byte[] src, int offset, int length) {
  int value;
  for (int i = offset; i < offset + length; i++) {
    value = src[i];
    buf[pos++] = HEXES[(value >> 4) & 0x0F];
    buf[pos++] = HEXES[value & 0x0F];
  }
  return this;
}

/**
 * 0x25 -> "25"
 *
 * @param value
 */
public StringHexComposer appendU8(int value) {
  buf[pos++] = HEXES[(value >> 4) & 0x0F];
  buf[pos++] = HEXES[value & 0x0F];
  return this;
}

/**
 *
 * @param value
 */
public StringHexComposer append(char value) {
  buf[pos++] = (byte) value;
  return this;
}

void writeToStream(OutputStream out) throws IOException {
  out.write(buf, 0, pos);

}

}
